jQuery.noConflict()(function ($) {
	// 词性跳转
	HWDSetup();

	$.fn.ignore = function (sel) {
		return this.clone().find(sel || ">*").remove().end();
	};

	function addSenseIndex(param) {
		var input = '';
		if ($(param).is('.pos')) {
			input = $(param).ignore(".gram").text() /*.toUpperCase()*/ .replace(' ,', ','); // Captalize pos
		} else {
			input = $(param).text().replace(' ,', ',');
		}

		var list = '';
		if ($(param).is('.pos')) {
			list += '<a href="#sense_' + noDictionary + '_' + noSense + '" class="sense num"><li>' + input + '<br /></li></a>';
		} else {
			list += '<a href="#sense_' + noDictionary + '_' + noSense + '" class="sense">' + input + '<br /></a>';
		}

		$(param).closest('.cam-body').prepend(list);
		$(param).before('<a name="sense_' + noDictionary + '_' + noSense + '"></a>');
		var jumpBackToSenseIndex = $('<a></a>');
		jumpBackToSenseIndex.attr('href', '#sense_index_' + noDictionary);
		$(param).wrap(jumpBackToSenseIndex);
	};

	function senseIndexAnimation(param) {
		var senseList = $('<ol></ol>');
		senseList.attr('class', 'sense_list');
		$(param).find('.pos-header .pos:not(.anc-info-head~.pos), .pos-body .guideword, .cols__col h3').closest('.cam-body').children('a').wrapAll(senseList);
		var senseIndex = $('<div></div>');
		senseIndex.attr('class', 'sense_index');
		$(param).find('.sense_list').wrap(senseIndex);
		$(param).find('.sense_index').prepend('<div class="contents">Contents</div>');
		$(param).find('.contents').animate({
			opacity: 1
		}, 250);
		$(param).find('.contents').click(function () {
			$(this).toggleClass('expanded');
			$(this).next().slideToggle(250);
		});
	};

	check = {};
	check.js = check.js || {};
	check.js.debugMode = false;
	check.isFirstLoad = function (namesp, jsFile) {
		var isFirst = namesp.firstLoad === undefined;
		namesp.firstLoad = false;
		return isFirst;
	};

	function HWDSetup() {
		if ($(".entry-body__el .headword").length > 1) {
			$(".entry-body__el .headword").css("cursor", "pointer").on("click.headword", function () {
				var _$HWDs = $(".entry-body__el .headword:visible");
				if (_$HWDs.length > 1) {
					var _index = _$HWDs.index(this);
					if (_index >= 0) {
						_index += 1;
						if (_index >= _$HWDs.length) {
							_index = 0;
						}
						scrollPosition(_$HWDs.eq(_index));
					}
				}
			});
		}
	}

	function scrollPosition(target) {
		$("html,body").animate({
			scrollTop: target.offset().top
		}, 500);
	};
	
	$(document).ready(function () {
		if (!check.isFirstLoad(check.js, "cambridge4.js")) {
			return;
		}

		$(".entry-body__el").wrapAll("<div class='cam-body' />");
		$('.cam-body').each(function (i) {
			if ($(this).find('.pos-header .pos:not(.anc-info-head~.pos), .pos-body .guideword, .cols__col h3').length > 1) {
				noDictionary = i;
				numberOfSense = $(this).find('.pos-header .pos:not(.anc-info-head~.pos), .pos-body .guideword, .cols__col h3').length;
				$($(this).find('.pos-header .pos:not(.anc-info-head~.pos), .pos-body .guideword, .cols__col h3').toArray().reverse()).each(function (j) {
					noSense = numberOfSense - j;
					addSenseIndex(this);
				});
				$(this).find('.pos-header .pos:not(.anc-info-head~.pos), .pos-body .guideword, .cols__col h3').closest('.cam-body').before('<a name="sense_index_' + noDictionary + '"></a>');
				senseIndexAnimation(this);
			}

		});

		$(".more_example_title").click(function () {
			var exampleSiblings = $(this).siblings("p.en_example")
			if (exampleSiblings.length > 0) {
				if (exampleSiblings.hasClass("active")) {
					exampleSiblings.removeClass("active");
					exampleSiblings.css({
						"display": "none"
					});
				} else {
					exampleSiblings.addClass("active");
					exampleSiblings.css({
						"display": "block"
					});
				}
			}
			if (exampleSiblings.length <= 0) {
				$(this).css({
					"color": "red"
				});
			}
		});
		
		// 英汉切换
		$("span.en_def").click(function () {
			var cn_def_Siblings = $(this).siblings("span.cn_def")
			if (cn_def_Siblings.length > 0) {
				if (cn_def_Siblings.hasClass("active")) {
					cn_def_Siblings.removeClass("active");
					cn_def_Siblings.css({
						"display": "none"
					});
				} else {
					cn_def_Siblings.addClass("active");
					cn_def_Siblings.css({
						"display": "inline"
					});
				}
			}
			if (cn_def_Siblings.length <= 0) {
				$(this).css({
					"color": "red"
				});
			}
		});

		$("span.en_example").click(function () {
			var cn_exampleSiblings = $(this).siblings("span.cn_example")
			if (cn_exampleSiblings.length > 0) {
				if (cn_exampleSiblings.hasClass("active")) {
					cn_exampleSiblings.removeClass("active");
					cn_exampleSiblings.css({
						"display": "none"
					});
				} else {
					cn_exampleSiblings.addClass("active");
					cn_exampleSiblings.css({
						"display": "inline"// 例句英汉在同一行 modified by MS
					});
				}
			}
			if (cn_exampleSiblings.length <= 0) {
				$(this).css({
					"color": "red"
				});
			}
		});
	});
})